#include <cstdio>
#include <cmath>
#define MIN(x, y) (x>y? y : x)
#define FOR(i, n) for(int i=0;i<n;++i)
using namespace std;

// 1010101010101010101010101010101010101010101010101010


long long tabl[4][1001][1001];
char ossz[1000][1000];

long long fgv(int index, int x2, int y2, int x, int y, int N, int M) {
	if (x>=N || y>=M || x < 0 || y < 0){
		tabl[index][x][y]=0;
		return 0;
		}
	if (tabl[index][x][y]!=-1) return tabl[index][x][y];
	if(!(x + x2 >= 0 && y + y2 >=0 && x + x2 < N && y + y2 < M)) return 0;
	if (ossz[x+x2][y]==ossz[x][y] && ossz[x][y]==ossz[x][y+y2]) {
		tabl[index][x][y]= MIN(fgv(index, x2, y2, x+x2, y, N, M), fgv(index, x2, y2, x, y+y2, N, M))+1;
	} else tabl[index][x][y]=0;
	return tabl[index][x][y];
}

long long solve(int N, int M) {
	FOR(k, 4)
		FOR(i, N) {
			FOR(j, M) {
				tabl[k][i][j]=-1;
			
			}
		
		}
	long long out=0;
	FOR(i, N) {
		FOR(j, M) {
			
			out+=fgv(0, 1,1, i, j, N, M);
			out+=fgv(1, -1,-1, i, j, N, M);
			out+=fgv(2, 1,-1, i, j, N, M);
			out+=fgv(3, -1,1, i, j, N, M);
			
			}
		}
		
	return out;

}


int main() {
	int N, M;
	scanf("%d%d\n",&N, &M);
	FOR(i, N) {
		FOR(j, M) {
			scanf("%c",&ossz[i][j]);
		}
		scanf("\n");
	}
	
	//printf("%c\n", ossz[0][0]);
	
	printf("%lld\n",solve(N, M));
}
